//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////
#include "scene.h"
//////////////////////////////////////////////////////////////////////

// Tu je vsetko co sa kresli
void scene::DrawGLScene()
{
	if(keys['L'] && keys[VK_CONTROL] || set.language_switch)
	{
		english = !english; 
		keys['L']=0;
		set.language_switch=0;
		for(int i=0; i<menu[0]->items.size(); i++)
		{
			if(english)
			{
				menu[0]->items[i].key = menu[1]->items[i].key;
			//	menu[0]->items[i].IntIndex = menu[1]->items[i].IntIndex;
				menu[0]->items[i].float_item.aktual = menu[1]->items[i].float_item.aktual;
			}
			else
			{
				menu[1]->items[i].key = menu[0]->items[i].key;
			//	menu[1]->items[i].IntIndex = menu[0]->items[i].IntIndex;
				menu[1]->items[i].float_item.aktual = menu[0]->items[i].float_item.aktual;
			}
		}
	}
	if(keys[VK_F1])
	{
		smenu=!smenu; 
		keys[VK_F1]=0;
		if(smenu)
			c->set_3ds_mouse_style();
		else
			c->set_q3_mouse_style();
	}

	if(anisotropic_filter_actual!=set.anisotropic_filter)
	{
		anisotropic_filter_actual=set.anisotropic_filter;
		texture::setAnisotropicFiltering(anisotropic_filter_actual);
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	// mazeme stancil buffer
	static vec speed(0,0,0);			// rychlost pre skakanie
	static int jump=0;					// nastavena na 1 ak sme v skoku
	static int ground=0;				// nastavena na 1 ak sme na zemi
	static int ground_return=0;
	if(smenu)
		c->SetTransform();
	else 
	{
		english ? menu[0]->ChangeSetting() : menu[1]->ChangeSetting();
		if(keys['R']){ speed.clear(); jump=0; ground=0; ground_return=0; }
		c->MoveWorld(fps, ROTATE_WALK);	// otoci svetom na zaklade vstupov od mysi a klavesnice
		if(set.gravitation && !set.collision_old)
		{
			if(!ground)
			{
				if( jump )
				{
					if( set.move_during_jump )
						c->vp = 0.5f*(c->vp-c->vp_old)+c->vp_old;	// 2 krat pomalsi pohyb vo vzduchu
					else
						c->vp = c->vp_old;		// ziadny pohyb mimo zeme
				}
				else
					c->vp.y = c->vp_old.y;		// ziadna zmena vysky
				speed += set.gravity_acceleration*timeframe*vec(0,-1,0);		// v = a*t, rychlost = zrychlenie*cas
			}
			if(keys[VK_SPACE])
			{
				if( set.jump_durind_jump || ground || ground_return )
				{
					speed = c->vp - c->vp_old;	// posledny pohyb
					speed *= fps;				// urobime ho nezavisli od fps
					speed.y = sqrt(2.f*set.gravity_acceleration*set.jump_height);
					ground = 0;
					jump = 1;
				}
				keys[VK_SPACE]=0;
			}
			if(!ground)c->vp += speed*timeframe;	// aplikujeme vplyv rychlosti
		}
	}

	int ground_old = ground;
	if(set.collision)
	{
		if(set.collision_old)
		{
			c->vp = base.CheckSimpleCollision( c->vp, set.sphere_radius);
		}
		else
		{
			collision.clear();
			float radius=set.sphere_radius;
			// 0.7072f namiesto 0.5f preto, lebo klzanim po polygonoch mozme vyjst aj mimo gule s polomerom 0.5f*dlzka kroku
			float radius_big=1.1f*radius+0.7072f*Length(c->vp-c->vp_old);		// big sphere - contain sphere: (vp,radius), (vp_old, radius)
			vec center_big = 0.5f*(c->vp+c->vp_old);
			base.AddCollisionFaces( &collision, center_big, radius_big );
			c->vp = CheckCollision( c->vp, c->vp_old, radius);
			if(set.gravitation)ground = CheckCollisionGround( c->vp, radius, 60.f, 0.01f*radius);
		}
	}

	if(set.gravitation && !set.collision_old)
	{
		if( ground)
		{
			jump=0;								// ak sme na zem tak neletime
			speed.clear();						// sme na zemy, nasa rychlost pre let je nulova
			ground_return=0;					// ak sme sa nastavili na navrat na zem a na zem sme sa aj vratili vynulujeme
		}
		else if(!ground_old)ground_return=0;
		if( ground_old && !ground && !jump)		// ak bola zem a teraz nie je a zaroven nie je skok
		{
			c->vp.y = c->vp_old.y;				// vratime sa na zem
			if(!ground_return)					// ak este nebol navrat na zem
			{
				ground=1;						// vratili sme sa na zem
				ground_return=1;				// priznak, aby sme sa nevracali na zem viackrat
			}
		}
	}
	// ak sme na zemy a pohybujeme sa smerom hore:
	// 1. ground=1; ground_old=1; ground_return=0; jump=0; 
	// 2. ground=1; ground_old=1; ground_return=1; jump=0;		// vratime sa naspat a nastavime ground_return na 1 a ground na 0
	// ak sa vratime na zem
	// 3a ground=1; ground_old=1; ground_return=0; jump=0;		// sme na zemy, ground_return sa nastavy na 0
	// ak nie sme na zemy
	// 3b ground=0; ground_old=1; ground_return=1; jump=0;		// vratime sa naspat ale kedze uz sme sa raz vracali, ground nechame na 0
	// 4. ground=0; ground_old=0; ground_return=0; jump=0;		// nie sme na zemy pouzije sa gravitacia, ground_return sa nuluje aby sme sa pocas padu nemohli odrazit
	// 5. ground=1; ground_old=0; ground_return=0; jump=0;		// vratili sme sa na zem ground_return sa vynuluje
	c->SetTransform();

/*	if(set.separate_specular)
	{	if(ext.EXT_separate_specular_color) glLightModeli( GL_LIGHT_MODEL_COLOR_CONTROL_EXT, GL_SEPARATE_SPECULAR_COLOR_EXT);}
	else
	{	if(ext.EXT_separate_specular_color) glLightModeli( GL_LIGHT_MODEL_COLOR_CONTROL_EXT, GL_SINGLE_COLOR_EXT);	}
*/	
	static vec l(-1.1f,3,-4.9f);
	if(set.light_update)l = c->vp;//+c->vd;
	if(set.lighting)
	{
		glEnable( GL_LIGHTING);
		vec4 lpos;	lpos = l;	lpos.w = 1.f;
		glLightfv ( GL_LIGHT0, GL_POSITION, lpos.v  );		// pozicia difuzneho svetla
	}

	if(set.cull_face)
	{
	//	glCullFace( GL_FRONT);
	//	glCullFace( GL_BACK);		// default
		glEnable(GL_CULL_FACE);
	}
	else
		glDisable(GL_CULL_FACE);
	
	if(!set.lmapt&&set.baset)base.Render(set.texturing, set.material, 0, set.faceNormal, set.line);
	if(set.lmapt&&!set.baset)base.Render(set.texturing, set.material, 1, set.faceNormal, set.line);
	if(set.lmapt&&set.baset)
	{
		if(set.use_multitexturing )base.RenderMultitexture( set.texturing, set.material, set.faceNormal, set.line);
		else
		{
			base.Render(set.texturing, set.material, 0, set.faceNormal, set.line);
			glDisable( GL_LIGHTING);
			glPolygonOffset( -1.f, -1.f);
			glEnable( GL_POLYGON_OFFSET_FILL);
			glEnable(GL_BLEND);
			glBlendFunc(GL_DST_COLOR, GL_ZERO);
			base.Render(set.texturing, 0, 1, set.faceNormal, set.line);
			glDisable( GL_BLEND);
			glDisable( GL_POLYGON_OFFSET_FILL);
		}
	}
	
	if(set.rendernormals)base.Render_normals( 1.f, set.faceNormal);
	glDisable( GL_LIGHTING);
	if(set.print_variable)
	{
		this->Print_vec( 0, 1, c->vp, english ? "position :" : "pozicia :");
		this->Print_vec( 0, 2, speed, english ? "velocity:" : "rychlost:");
		this->Print_int( 0, 3, ground, "ground" );
		this->Print_int( 0, 4, ground_return, "ground return" );
		this->Print_int( 0, 5, ground||ground_return, english ? "ground or g return" : "ground alebo g return" );
		this->Print_int( 0, 6, jump, english ? "jump" : "skok" );
	}
/*	this->Print_vec( 0, 1, c->vp, "vp");
	this->Print_vec( 0, 2, c->vr, "vr");
	this->Print_vec( 0, 3, c->vu, "vu");
	this->Print_vec( 0, 4, c->vd, "vd");
*/
	glColor4f(1,1,1,1);
	if(keys[VK_F12]){	SaveScreen_BMP(); keys[VK_F12] = 0;}

#ifdef _DEBUG
	Timer t1;
	t1.Reset();
	while(t1.GetTime()<set.time_delay);
#endif

	// vypis FPS
	glEnable( GL_TEXTURE_2D);
	font0->Begin();
	timeframe = timer0.GetTime();
	fps = 1.0f / timeframe;
	timer0.Reset();
	fps_counter.GetAvgFps(timeframe,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);

	if(set.help)							// zobrazenie helpu
	{
		int i=1;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.6f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(0,0);
			glVertex2i(800,0);
			glVertex2i(800,600-16);
			glVertex2i(0,600-16);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);
		font0->Print(15,i++,"Program: ASE loader",0);
		glColor3f(0.9f,0.9f,1.0f);
		if(english)
		{
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Controls:",0);
			font0->Print(2,i++,"F1 - show/hide menu",1);
			font0->Print(2,i++,"Menu is to control arrow and mouse.",1);
			font0->Print(2,i++,"Character on right is to use to control item out of menu.",1);
			font0->Print(2,i++,"Setting press relevant key, cancellation press backspace",1);
			font0->Print(2,i++,"Setting of numeric value, arrow right, left, shift, mouse",1);
			font0->Print(2,i++,"In program, press key increase, shift+key. decrease",1);
			font0->Print(2,i++,"F4 - switch to window",1);
			font0->Print(2,i++,"F12 - take screenshot",1);
			font0->Print(2,i++,"H - help",1);
			i++;
			font0->Print(2,i++,"Controls of camera:",0);
			font0->Print_scale(2,i++,"W,S,arrow up,down,left and right button - move forward and backward",1,0.94f,1);
			font0->Print(2,i++,"A,D,Delete,Insert - move left and right",1);
			font0->Print(2,i++,"Home,End - move up and down",1);
			font0->Print(2,i++,"arrow right,left and moving mouse <-> - rotation about y axis",1);
			font0->Print(2,i++,"Page Up, Page Down a moving mouse | - rotation about x axis",1);
			font0->Print(2,i++,"Shift - slow moving",1);
			font0->Print(2,i++,"R - reset camera",1);
		}
		else
		{
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Pouzivane klavesy:",0);
			font0->Print(2,i++,"F1 - zobrazy/skryje menu",1);
			font0->Print(2,i++,"Menu sa ovlada sipkamy a mysov.",1);
			font0->Print(2,i++,"Znak na pravo sa pouziva na ovladanie danej polozky mimo menu",1);
			font0->Print(2,i++,"Nastavenie stlacenim prislusnej klavesy, zrusenie backspace",1);
			font0->Print(2,i++,"Nastavenie ciselnej hodnoty, sipky vpravo vlavo, shift, mysov",1);
			font0->Print(2,i++,"V programe, klavesov zvysovanie, shift+klav. znizovanie",1);
			font0->Print(2,i++,"F4 - prepne do okna",1);
			font0->Print(2,i++,"F12 - urobi screenshot",1);
			font0->Print(2,i++,"medzernik - skok",1);
			i++;
			font0->Print(2,i++,"Ovladanie kamery:",0);
			font0->Print_scale(2,i++,"W,S,sipka hore,dole,lave a prave tlacitko - pohyb dopredu a dozadu",1,0.94f,1);
			font0->Print(2,i++,"A,D,Delete,Insert - pohyb do boka vlavo vpravo",1);
			font0->Print(2,i++,"Home,End - pohyb hore, dole",1);
			font0->Print(2,i++,"sipka vpravo,vlavo a pohyb mysov <->  - rotacia okolo osi y",1);
			font0->Print(2,i++,"Page Up, Page Down a pohyb mysov | - rotacia okolo osi x",1);
			font0->Print(2,i++,"Shift - pomalsi pohyb",1);
			font0->Print(2,i++,"R - reset kamery",1);
		}
	}
	font0->End();
	if(smenu)english ? menu[0]->Render() : menu[1]->Render();
}
